<template>
    <div class="piechart">
        <canvas ref="canvasElement" width="250" height="250"/>
    </div>
</template>

<script>
import {Chart} from '../shared/chart'
import * as colors from '../shared/colors.js'

export default {
    data() {
        return {
            chart: undefined,
        }
    },
    computed: {
        selectedFruitBasket() {
            return this.$store.state.selectedFruitBasket
        }
    },
    mounted() {
        this.subscriptionUpdated()
    },
    watch: {
        selectedFruitBasket() {
            this.subscriptionUpdated()
        }
    },
    methods: {
        subscriptionUpdated() {
            if (!this.$refs.canvasElement) return;
            if (!this.chart) {
                this.initChart()
            } else {
                this.updateChart()
            }
        },
        initChart() {
            this.chart = new Chart(this.$refs.canvasElement, {
                type: "pie",
                data: {
                    datasets: [
                        {
                            data: [
                                this.selectedFruitBasket.nApples,
                                this.selectedFruitBasket.nOranges
                            ],
                            backgroundColor: [colors.red, colors.orange]
                        }
                    ],
                    labels: ["Apples", "Oranges"]
                }
            });
        },
        updateChart() {
            this.chart.data.datasets[0].data = [
                this.selectedFruitBasket.nApples,
                this.selectedFruitBasket.nOranges,
            ];

            this.chart.update();
        }
    }
}
</script>


<style lang="scss" scoped>
@import '../styles/_variables';

.piechart {
  background-color: $white;
  border-radius: 0.5rem;
  box-shadow: 1px 1px 3px $gray;
  overflow: hidden;
  padding: 2rem;
  width: 250px;
  height: 250px;
}

canvas {
  pointer-events: none;
}

</style>
